Index: src/Parser/PcpParser.cpp
===================================================================
--- src/Parser/PcpParser.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Parser/PcpParser.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,6 +6,15 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "Helpers/MemDebug.hpp"
+
 #include <iostream>
-
+#include <iomanip>
+
+//#include "Actions/FragmentationAction/SubgraphDissectionAction.hpp"
 #include "atom.hpp"
 #include "config.hpp"
@@ -13,82 +22,112 @@
 #include "element.hpp"
 #include "Helpers/Assert.hpp"
-#include "log.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
+#include "LinearAlgebra/Matrix.hpp"
 #include "molecule.hpp"
 #include "PcpParser.hpp"
 #include "periodentafel.hpp"
 #include "ThermoStatContainer.hpp"
-#include "verbose.hpp"
 #include "World.hpp"
+#include "Box.hpp"
+
+
+PcpParser::StructParallelization::StructParallelization() :
+  ProcPEGamma(8),
+  ProcPEPsi(1)
+{}
+
+PcpParser::StructParallelization::~StructParallelization()
+{}
+
+PcpParser::StructPaths::StructPaths() :
+  databasepath(NULL),
+  configname(NULL),
+  mainname(NULL),
+  defaultpath(NULL),
+  pseudopotpath(NULL)
+{}
+
+PcpParser::StructPaths::~StructPaths()
+{}
+
+PcpParser::StructSwitches::StructSwitches() :
+  DoConstrainedMD(0),
+  DoOutVis(0),
+  DoOutMes(1),
+  DoOutNICS(0),
+  DoOutOrbitals(0),
+  DoOutCurrent(0),
+  DoFullCurrent(0),
+  DoPerturbation(0),
+  DoWannier(0)
+{}
+
+PcpParser::StructSwitches::~StructSwitches()
+{}
+
+PcpParser::StructLocalizedOrbitals::StructLocalizedOrbitals() :
+  CommonWannier(0),
+  SawtoothStart(0.01),
+  VectorPlane(0),
+  VectorCut(0),
+  UseAddGramSch(1),
+  Seed(1),
+  EpsWannier(1e-7)
+{}
+
+PcpParser::StructLocalizedOrbitals::~StructLocalizedOrbitals()
+{}
+
+PcpParser::StructStepCounts::StructStepCounts() :
+  MaxMinStopStep(1),
+  InitMaxMinStopStep(1),
+  OutVisStep(10),
+  OutSrcStep(5),
+  MaxPsiStep(0),
+  MaxOuterStep(0),
+  MaxMinStep(100),
+  RelEpsTotalEnergy(1e-07),
+  RelEpsKineticEnergy(1e-05),
+  MaxMinGapStopStep(0),
+  MaxInitMinStep(100),
+  InitRelEpsTotalEnergy(1e-05),
+  InitRelEpsKineticEnergy(0.0001),
+  InitMaxMinGapStopStep(0)
+{}
+
+PcpParser::StructStepCounts::~StructStepCounts()
+{}
+
+PcpParser::StructPlaneWaveSpecifics::StructPlaneWaveSpecifics() :
+  PsiType(0),
+  MaxPsiDouble(0),
+  PsiMaxNoUp(0),
+  PsiMaxNoDown(0),
+  ECut(128),
+  MaxLevel(5),
+  RiemannTensor(0),
+  LevRFactor(0),
+  RiemannLevel(0),
+  Lev0Factor(2),
+  RTActualUse(0),
+  AddPsis(0),
+  RCut(20)
+{}
+
+PcpParser::StructPlaneWaveSpecifics::~StructPlaneWaveSpecifics()
+{}
 
 /** Constructor of PcpParser.
  *
  */
-PcpParser::PcpParser()
-{
-  Parallelization.ProcPEGamma = 8;
-  Parallelization.ProcPEPsi = 1;
-
-  Paths.databasepath = NULL;
-  Paths.configname = NULL;
-  Paths.mainname = NULL;
-  Paths.defaultpath = NULL;
-  Paths.pseudopotpath = NULL;
-
-  Switches.DoConstrainedMD = 0;
-  Switches.DoOutVis = 0;
-  Switches.DoOutMes = 1;
-  Switches.DoOutNICS = 0;
-  Switches.DoOutOrbitals = 0;
-  Switches.DoOutCurrent = 0;
-  Switches.DoFullCurrent = 0;
-  Switches.DoPerturbation = 0;
-  Switches.DoWannier = 0;
-
-  LocalizedOrbitals.CommonWannier = 0;
-  LocalizedOrbitals.SawtoothStart = 0.01;
-  LocalizedOrbitals.VectorPlane = 0;
-  LocalizedOrbitals.VectorCut = 0;
-  LocalizedOrbitals.UseAddGramSch = 1;
-  LocalizedOrbitals.Seed = 1;
-  LocalizedOrbitals.EpsWannier = 1e-7;
-
-  StepCounts.MaxMinStopStep = 1;
-  StepCounts.InitMaxMinStopStep = 1;
-  StepCounts.OutVisStep = 10;
-  StepCounts.OutSrcStep = 5;
-  StepCounts.MaxPsiStep = 0;
-  StepCounts.MaxOuterStep = 0;
-  StepCounts.MaxMinStep = 100;
-  StepCounts.RelEpsTotalEnergy = 1e-07;
-  StepCounts.RelEpsKineticEnergy = 1e-05;
-  StepCounts.MaxMinGapStopStep = 0;
-  StepCounts.MaxInitMinStep = 100;
-  StepCounts.InitRelEpsTotalEnergy = 1e-05;
-  StepCounts.InitRelEpsKineticEnergy = 0.0001;
-  StepCounts.InitMaxMinGapStopStep = 0;
-
-  PlaneWaveSpecifics.PsiType = 0;
-  PlaneWaveSpecifics.MaxPsiDouble = 0;
-  PlaneWaveSpecifics.PsiMaxNoUp = 0;
-  PlaneWaveSpecifics.PsiMaxNoDown = 0;
-  PlaneWaveSpecifics.ECut = 128;
-  PlaneWaveSpecifics.MaxLevel = 5;
-  PlaneWaveSpecifics.RiemannTensor = 0;
-  PlaneWaveSpecifics.LevRFactor = 0;
-  PlaneWaveSpecifics.RiemannLevel = 0;
-  PlaneWaveSpecifics.Lev0Factor = 2;
-  PlaneWaveSpecifics.RTActualUse = 0;
-  PlaneWaveSpecifics.AddPsis = 0;
-  PlaneWaveSpecifics.RCut = 20;
-  PlaneWaveSpecifics.PsiType = 0;
-
-  FastParsing = false;
-
-  Deltat = 0.01;
-  IsAngstroem = 1;
-  RelativeCoord = 0;
-  StructOpt = 0;
-  MaxTypes = 0;
-}
+PcpParser::PcpParser() :
+  FastParsing(false),
+  Deltat(0.01),
+  IsAngstroem(1),
+  RelativeCoord(0),
+  StructOpt(0),
+  MaxTypes(0)
+{}
 
 /** Destructor of PcpParser.
@@ -210,5 +249,5 @@
   // Unit cell and magnetic field
   ParseForParameter(verbose,FileBuffer, "BoxLength", 0, 3, 3, lower_trigrid, BoxLength, 1, critical); /* Lattice->RealBasis */
-  double * const cell_size = World::getInstance().getDomain();
+  double *cell_size = new double[6];
   cell_size[0] = BoxLength[0];
   cell_size[1] = BoxLength[3];
@@ -217,4 +256,6 @@
   cell_size[4] = BoxLength[7];
   cell_size[5] = BoxLength[8];
+  World::getInstance().setDomain(cell_size);
+  delete[] cell_size;
   //if (1) fprintf(stderr,"\n");
 
@@ -316,5 +357,5 @@
   // 4. dissect the molecule into connected subgraphs
   // don't do this here ...
-  //MolList->DissectMoleculeIntoConnectedSubgraphs(mol,this);
+  //FragmentationSubgraphDissection();
   //delete(mol);
 
@@ -327,5 +368,7 @@
 void PcpParser::save(std::ostream* file)
 {
-  const double * const cell_size = World::getInstance().getDomain();
+  DoLog(0) && (Log() << Verbose(0) << "Saving changes to pcp." << std::endl);
+
+  const Matrix &domain = World::getInstance().getDomain().getM();
   class ThermoStatContainer *Thermostats = World::getInstance().getThermostats();
   if (!file->fail()) {
@@ -412,7 +455,7 @@
     *file << endl;
     *file << "BoxLength\t\t\t# (Length of a unit cell)" << endl;
-    *file << cell_size[0] << "\t" << endl;
-    *file << cell_size[1] << "\t" << cell_size[2] << "\t" << endl;
-    *file << cell_size[3] << "\t" << cell_size[4] << "\t" << cell_size[5] << "\t" << endl;
+    *file << domain.at(0,0) << "\t" << endl;
+    *file << domain.at(1,0) << "\t" << domain.at(1,1) << "\t" << endl;
+    *file << domain.at(2,0) << "\t" << domain.at(2,1) << "\t" << domain.at(2,2) << "\t" << endl;
     // FIXME
     *file << endl;
@@ -455,5 +498,5 @@
   PlaneWaveSpecifics.MaxPsiDouble = PlaneWaveSpecifics.PsiMaxNoDown = PlaneWaveSpecifics.PsiMaxNoUp = PlaneWaveSpecifics.PsiType = 0;
   for (vector<atom *>::iterator runner = allatoms.begin(); runner != allatoms.end(); ++runner) {
-    PlaneWaveSpecifics.MaxPsiDouble += (*runner)->type->NoValenceOrbitals;
+    PlaneWaveSpecifics.MaxPsiDouble += (*runner)->getType()->NoValenceOrbitals;
   }
   cout << PlaneWaveSpecifics.MaxPsiDouble << endl;
@@ -490,5 +533,5 @@
   // insert all found elements into the map
   for (vector<atom *>::iterator AtomRunner = allatoms.begin();AtomRunner != allatoms.end();++AtomRunner) {
-    Inserter = PresentElements.insert(pair<int, int>((*AtomRunner)->type->Z, 1));
+    Inserter = PresentElements.insert(pair<int, int>((*AtomRunner)->getType()->Z, 1));
     if (!Inserter.second) // increase if present
       Inserter.first->second += 1;
@@ -505,5 +548,5 @@
     const element * const elemental = World::getInstance().getPeriode()->FindElement(iter->first);
     ZtoIndexMap.insert( pair<int,int> (iter->first, counter) );
-    *file << "Ion_Type" << counter++ << "\t" << iter->second << "\t" << elemental->Z << "\t1.0\t3\t3\t" << fixed << setprecision(11) << showpoint << elemental->mass << "\t" << elemental->name << "\t" << elemental->symbol <<endl;
+    *file << "Ion_Type" << counter++ << "\t" << iter->second << "\t" << elemental->Z << "\t1.0\t3\t3\t" << fixed << setprecision(11) << showpoint << elemental->mass << "\t" << elemental->getName() << "\t" << elemental->getSymbol() <<endl;
   }
 }
@@ -521,13 +564,13 @@
   int nr = 0;
   for (vector<atom *>::iterator AtomRunner = allatoms.begin();AtomRunner != allatoms.end();++AtomRunner) {
-    Inserter = ZtoCountMap.insert( pair<int, int>((*AtomRunner)->type->Z, 1) );
+    Inserter = ZtoCountMap.insert( pair<int, int>((*AtomRunner)->getType()->Z, 1) );
     if (!Inserter.second)
       Inserter.first->second += 1;
-    const int Z = (*AtomRunner)->type->Z;
+    const int Z = (*AtomRunner)->getType()->Z;
     *file << "Ion_Type" << ZtoIndexMap[Z] << "_" << ZtoCountMap[Z] << "\t"  << fixed << setprecision(9) << showpoint;
-    *file << (*AtomRunner)->x[0] << "\t" << (*AtomRunner)->x[1] << "\t" << (*AtomRunner)->x[2];
+    *file << (*AtomRunner)->at(0) << "\t" << (*AtomRunner)->at(1) << "\t" << (*AtomRunner)->at(2);
     *file << "\t" << (*AtomRunner)->FixedIon;
-    if ((*AtomRunner)->v.Norm() > MYEPSILON)
-      *file << "\t" << scientific << setprecision(6) << (*AtomRunner)->v[0] << "\t" << (*AtomRunner)->v[1] << "\t" << (*AtomRunner)->v[2] << "\t";
+    if ((*AtomRunner)->AtomicVelocity.Norm() > MYEPSILON)
+      *file << "\t" << scientific << setprecision(6) << (*AtomRunner)->AtomicVelocity[0] << "\t" << (*AtomRunner)->AtomicVelocity[1] << "\t" << (*AtomRunner)->AtomicVelocity[2] << "\t";
     *file << " # molecule nr " << nr++ << endl;
   }
Index: src/Parser/PcpParser.hpp
===================================================================
--- src/Parser/PcpParser.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Parser/PcpParser.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -9,5 +9,5 @@
 #define PCPPARSER_HPP_
 
-#include <iostream>
+#include <iosfwd>
 #include "Parser/FormatParser.hpp"
 
@@ -31,5 +31,9 @@
   void CalculateOrbitals(vector<atom *> &allatoms);
 
-  struct StructParallelization {
+  class StructParallelization {
+  public:
+    StructParallelization();
+    ~StructParallelization();
+
     int ProcPEGamma;
     int ProcPEPsi;
@@ -39,5 +43,9 @@
    * Contains all the paths and names
    */
-  struct StructPaths {
+  class StructPaths {
+  public:
+    StructPaths();
+    ~StructPaths();
+
     char *databasepath;
     char *configname;
@@ -50,5 +58,9 @@
    * Contains all Do/Don't switches
    */
-  struct StructSwitches {
+  class StructSwitches {
+  public:
+    StructSwitches();
+    ~StructSwitches();
+
     int DoConstrainedMD;
     int DoOutVis;
@@ -65,5 +77,9 @@
    * Contains parameters regarding localization of orbitals or magnetic perturbation
    */
-  struct StructLocalizedOrbitals {
+  class StructLocalizedOrbitals {
+  public:
+    StructLocalizedOrbitals();
+    ~StructLocalizedOrbitals();
+
     int CommonWannier;
     double SawtoothStart;
@@ -78,5 +94,9 @@
    * Contains all step count and other epsilon threshold parameters
    */
-  struct StructStepCounts {
+  class StructStepCounts {
+  public:
+    StructStepCounts();
+    ~StructStepCounts();
+
     int MaxMinStopStep;
     int InitMaxMinStopStep;
@@ -101,5 +121,9 @@
    * Contains all parameters specific to the plane wave basis set
    */
-  struct StructPlaneWaveSpecifics {
+  class StructPlaneWaveSpecifics {
+  public:
+    StructPlaneWaveSpecifics();
+    ~StructPlaneWaveSpecifics();
+
     int PsiType;
     int MaxPsiDouble;
Index: src/Parser/TremoloParser.cpp
===================================================================
--- src/Parser/TremoloParser.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Parser/TremoloParser.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,7 +6,14 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Helpers/Assert.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "TremoloParser.hpp"
 #include "World.hpp"
@@ -21,5 +28,4 @@
 
 using namespace std;
-using namespace boost;
 
 /**
@@ -99,4 +105,6 @@
  */
 void TremoloParser::save(ostream* file) {
+  DoLog(0) && (Log() << Verbose(0) << "Saving changes to tremolo." << std::endl);
+
   vector<atom*>::iterator atomIt;
   vector<string>::iterator it;
@@ -140,13 +148,13 @@
       case TremoloKey::x :
         // for the moment, assume there are always three dimensions
-        *file << currentAtom->x[0] << "\t";
-        *file << currentAtom->x[1] << "\t";
-        *file << currentAtom->x[2] << "\t";
+        *file << currentAtom->at(0) << "\t";
+        *file << currentAtom->at(1) << "\t";
+        *file << currentAtom->at(2) << "\t";
         break;
       case TremoloKey::u :
         // for the moment, assume there are always three dimensions
-        *file << currentAtom->v[0] << "\t";
-        *file << currentAtom->v[1] << "\t";
-        *file << currentAtom->v[2] << "\t";
+        *file << currentAtom->AtomicVelocity[0] << "\t";
+        *file << currentAtom->AtomicVelocity[1] << "\t";
+        *file << currentAtom->AtomicVelocity[2] << "\t";
         break;
       case TremoloKey::Type :
@@ -225,4 +233,5 @@
   string word;
   int oldId;
+  double tmp;
 
   lineStream << line;
@@ -232,13 +241,14 @@
       case TremoloKey::x :
         // for the moment, assume there are always three dimensions
-        lineStream >> newAtom->x[0];
-        lineStream >> newAtom->x[1];
-        lineStream >> newAtom->x[2];
+        for (int i=0;i<NDIM;i++) {
+          lineStream >> tmp;
+          newAtom->set(i, tmp);
+        }
         break;
       case TremoloKey::u :
         // for the moment, assume there are always three dimensions
-        lineStream >> newAtom->v[0];
-        lineStream >> newAtom->v[1];
-        lineStream >> newAtom->v[2];
+        lineStream >> newAtom->AtomicVelocity[0];
+        lineStream >> newAtom->AtomicVelocity[1];
+        lineStream >> newAtom->AtomicVelocity[2];
         break;
       case TremoloKey::Type :
@@ -385,23 +395,23 @@
 
 
-TremoloAtomInfoContainer::TremoloAtomInfoContainer() {
-  F = "0";
-  stress = "0";
-  imprData = "-";
-  GroupMeasureTypeNo = "0";
-  extType = "-";
-  name = "-";
-  resName = "-";
-  chainID = "0";
-  resSeq = "0";
-  occupancy = "0";
-  tempFactor = "0";
-  segID = "0";
-  Charge = "0";
-  charge = "0";
-  GrpTypeNo = "0";
-  torsion = "-";
-  neighbors = vector<int>(0, 5);
-}
+TremoloAtomInfoContainer::TremoloAtomInfoContainer() :
+  F("0"),
+  stress("0"),
+  imprData("-"),
+  GroupMeasureTypeNo("0"),
+  extType("-"),
+  name("-"),
+  resName("-"),
+  chainID("0"),
+  resSeq("0"),
+  occupancy("0"),
+  tempFactor("0"),
+  segID("0"),
+  Charge("0"),
+  charge("0"),
+  GrpTypeNo("0"),
+  torsion("-"),
+  neighbors(vector<int>(0, 5))
+{}
 
 void TremoloAtomInfoContainer::set(TremoloKey::atomDataKey key, string value) {
Index: src/Parser/XyzParser.cpp
===================================================================
--- src/Parser/XyzParser.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Parser/XyzParser.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,9 +6,17 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 #include "XyzParser.hpp"
 #include "World.hpp"
 #include "atom.hpp"
+#include "molecule.hpp"
 #include "element.hpp"
 #include "periodentafel.hpp"
@@ -19,7 +27,7 @@
  * Constructor.
  */
-XyzParser::XyzParser() {
-  comment = "";
-}
+XyzParser::XyzParser() :
+  comment("")
+{}
 
 /**
@@ -35,7 +43,9 @@
  */
 void XyzParser::load(istream* file) {
-  atom* newAtom;
+  atom* newAtom = NULL;
+  molecule* newmol = NULL;
   int numberOfAtoms;
   char commentBuffer[512], type[3];
+  double tmp;
 
   // the first line tells number of atoms, the second line is always a comment
@@ -44,8 +54,17 @@
   comment = commentBuffer;
 
+  newmol = World::getInstance().createMolecule();
+  newmol->ActiveFlag = true;
+  // TODO: Remove the insertion into molecule when saving does not depend on them anymore. Also, remove molecule.hpp include
+  World::getInstance().getMolecules()->insert(newmol);
   for (int i = 0; i < numberOfAtoms; i++) {
     newAtom = World::getInstance().createAtom();
-    *file >> type >> ws >> newAtom->x[0] >> ws >> newAtom->x[1] >> ws >> newAtom->x[2];
+    *file >> type;
+    for (int j=0;j<NDIM;j++) {
+      *file >> tmp;
+      newAtom->set(j, tmp);
+    }
     newAtom->setType(World::getInstance().getPeriode()->FindElement(type));
+    newmol->AddAtom(newAtom);
   }
 }
@@ -57,4 +76,5 @@
  */
 void XyzParser::save(ostream* file) {
+  DoLog(0) && (Log() << Verbose(0) << "Saving changes to xyz." << std::endl);
   if (comment == "") {
     time_t now = time((time_t *)NULL);   // Get the system time and put it into 'now' as 'calender time'
@@ -72,5 +92,5 @@
   vector<atom*> atoms = World::getInstance().getAllAtoms();
   for(vector<atom*>::iterator it = atoms.begin(); it != atoms.end(); it++) {
-    *file << noshowpoint << (*it)->getType()->symbol << "\t" << (*it)->x[0] << "\t" << (*it)->x[1] << "\t" << (*it)->x[2] << endl;
+    *file << noshowpoint << (*it)->getType()->getSymbol() << "\t" << (*it)->at(0) << "\t" << (*it)->at(1) << "\t" << (*it)->at(2) << endl;
   }
 }
Index: src/Patterns/Cacheable.hpp
===================================================================
--- src/Patterns/Cacheable.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Patterns/Cacheable.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -12,5 +12,4 @@
 #include <boost/function.hpp>
 #include <boost/shared_ptr.hpp>
-#include <iostream>
 
 #include "Helpers/Assert.hpp"
Index: src/Patterns/ObservedContainer.hpp
===================================================================
--- src/Patterns/ObservedContainer.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Patterns/ObservedContainer.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,95 @@
+/*
+ * AtomSet.hpp
+ *
+ *  Created on: Jul 8, 2010
+ *      Author: crueger
+ */
+
+#ifndef OBSERVEDCONTAINER_HPP_
+#define OBSERVEDCONTAINER_HPP_
+
+#include "types.hpp"
+
+#include <utility>
+#include "Patterns/ObservedIterator.hpp"
+#include "Descriptors/SelectiveIterator.hpp"
+
+class World;
+class atom;
+class AtomDescriptor;
+
+/**
+ * Forward to std::map<atomId_t,atom*> that allows production of observed and
+ * unobserved iterators to all atoms.
+ *
+ * Imported via typedef into class World. Defined here to avoid bloating of the
+ * World class
+ */
+template <class Container>
+class ObservedContainer
+{
+  friend class World;
+
+public:
+  typedef Container set_t;
+  // this iterator can be used for internal purposes...
+  // no lock used here
+  typedef typename set_t::iterator                              internal_iterator;
+  typedef typename std::reverse_iterator<internal_iterator>     reverse_internal_iterator;
+
+  // typedefs for iterator structure
+  typedef ObservedIterator<set_t>                               iterator;
+  typedef typename set_t::const_iterator                        const_iterator;
+  typedef std::reverse_iterator<iterator>                       reverse_iterator;
+  typedef typename std::reverse_iterator<const_iterator>        const_reverse_iterator;
+
+  // some more typedefs for STL-Structure
+  typedef typename set_t::key_type               key_type;
+  typedef typename set_t::mapped_type            mapped_type;
+  typedef typename set_t::value_type             value_type;
+  typedef typename set_t::key_compare            key_compare;
+  typedef typename set_t::allocator_type         allocator_type;
+
+  ObservedContainer(Observable*);
+  ObservedContainer(const ObservedContainer&);
+  virtual ~ObservedContainer();
+
+  // all the functions from STL-map (forwards to content)
+  ObservedContainer& operator=(const ObservedContainer&);
+
+  iterator                      begin();
+  const_iterator                begin()         const;
+  iterator                      end();
+  const_iterator                end()           const;
+  reverse_iterator              rbegin();
+  const_reverse_iterator        rbegin()        const;
+  reverse_iterator              rend();
+  const_reverse_iterator        rend()          const;
+
+  bool empty() const;
+  size_t size() const;
+  size_t max_size() const;
+
+  mapped_type &operator[](const key_type&);
+
+  std::pair<iterator,bool> insert (const value_type&);
+
+  size_t erase ( const key_type& x );
+  void clear();
+
+  iterator              find ( const key_type& x );
+  const_iterator        find ( const key_type& x ) const;
+
+  size_t count ( const key_type& x ) const;
+  internal_iterator             begin_internal();
+  internal_iterator             end_internal();
+  reverse_internal_iterator     rbegin_internal();
+  reverse_internal_iterator     rend_internal();
+
+  set_t &getContent();
+private:
+  set_t content;
+  Observable *obs;
+};
+
+#endif /* OBSERVEDCONTAINER_HPP_ */
Index: src/Patterns/ObservedContainer_impl.hpp
===================================================================
--- src/Patterns/ObservedContainer_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
+++ src/Patterns/ObservedContainer_impl.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -0,0 +1,215 @@
+/*
+ * AtomSet_impl.hpp
+ *
+ *  Created on: Jul 8, 2010
+ *      Author: crueger
+ */
+
+#ifndef OBSERVEDCONTAINER_IMPL_HPP_
+#define OBSERVEDCONTAINER_IMPL_HPP_
+
+#include "Patterns/ObservedContainer.hpp"
+
+template <class Container>
+inline ObservedContainer<Container>::ObservedContainer(Observable* _obs) :
+  obs(_obs)
+{}
+
+template <class Container>
+inline ObservedContainer<Container>::ObservedContainer(const ObservedContainer<Container> &src) :
+  content(src.content),
+  obs(src.obs)
+{}
+
+template <class Container>
+inline ObservedContainer<Container>::~ObservedContainer()
+{}
+
+template <class Container>
+inline
+ObservedContainer<Container>&
+ObservedContainer<Container>::operator=(const ObservedContainer<Container> &rhs){
+  content=rhs.content;
+  return *this;
+}
+
+template <class Container>
+inline
+typename ObservedContainer<Container>::iterator
+ObservedContainer<Container>::begin(){
+  return ObservedContainer<Container>::iterator(content.begin(),obs);
+}
+
+template <class Container>
+inline
+typename ObservedContainer<Container>::const_iterator
+ObservedContainer<Container>::begin() const{
+  return content.begin();
+}
+
+template <class Container>
+inline
+typename ObservedContainer<Container>::iterator
+ObservedContainer<Container>::end(){
+  return ObservedContainer<Container>::iterator(content.end(),obs);
+}
+
+template <class Container>
+inline
+typename ObservedContainer<Container>::const_iterator
+ObservedContainer<Container>::end() const{
+  return content.end();
+}
+
+template <class Container>
+inline
+typename ObservedContainer<Container>::reverse_iterator
+ObservedContainer<Container>::rbegin(){
+  return reverse_iterator(begin());
+}
+
+template <class Container>
+inline
+typename ObservedContainer<Container>::const_reverse_iterator
+ObservedContainer<Container>::rbegin() const{
+  return const_reverse_iterator(begin());
+}
+
+template <class Container>
+inline
+typename ObservedContainer<Container>::reverse_iterator
+ObservedContainer<Container>::rend(){
+  return reverse_iterator(end());
+}
+
+template <class Container>
+inline
+typename ObservedContainer<Container>::const_reverse_iterator
+ObservedContainer<Container>::rend() const{
+  return const_reverse_iterator(end());
+}
+
+template <class Container>
+inline bool ObservedContainer<Container>::empty() const{
+  return content.empty();
+}
+
+template <class Container>
+inline size_t ObservedContainer<Container>::size() const{
+  return content.size();
+}
+
+template <class Container>
+inline size_t ObservedContainer<Container>::max_size() const{
+  return content.max_size();
+}
+
+template <class Container>
+inline
+typename ObservedContainer<Container>::mapped_type &
+ObservedContainer<Container>::operator[](const key_type &key){
+  return content[key];
+}
+
+template <class Container>
+inline
+std::pair<typename ObservedContainer<Container>::iterator,bool>
+ObservedContainer<Container>::insert (const value_type &value){
+  std::pair<typename set_t::iterator,bool> res = content.insert(value);
+  return std::make_pair(iterator(res.first,obs),res.second);
+}
+
+template <class Container>
+inline size_t ObservedContainer<Container>::erase ( const key_type& x ){
+  return content.erase(x);
+}
+
+template <class Container>
+inline void ObservedContainer<Container>::clear(){
+  content.clear();
+}
+
+template <class Container>
+inline
+typename ObservedContainer<Container>::iterator
+ObservedContainer<Container>::find ( const key_type& x ){
+  return iterator(content.find(x),obs);
+}
+
+template <class Container>
+inline
+typename ObservedContainer<Container>::const_iterator
+ObservedContainer<Container>::find ( const key_type& x ) const{
+  return content.find(x);
+}
+
+template <class Container>
+inline size_t ObservedContainer<Container>::count ( const key_type& x ) const{
+  return content.count(x);
+}
+
+/************ Unprotected access ***************/
+
+template <class Container>
+inline
+typename ObservedContainer<Container>::internal_iterator
+ObservedContainer<Container>::begin_internal(){
+  return content.begin();
+}
+
+template <class Container>
+inline
+typename ObservedContainer<Container>::internal_iterator
+ObservedContainer<Container>::end_internal(){
+  return content.end();
+}
+
+template <class Container>
+inline
+typename ObservedContainer<Container>::reverse_internal_iterator
+ObservedContainer<Container>::rbegin_internal(){
+  return content.rbegin();
+}
+
+template <class Container>
+inline
+typename ObservedContainer<Container>::reverse_internal_iterator
+ObservedContainer<Container>::rend_internal(){
+  return content.rend();
+}
+
+template <class Container>
+inline
+typename ObservedContainer<Container>::set_t &
+ObservedContainer<Container>::getContent(){
+  return content;
+}
+
+/************ Explicit instantiation ***************/
+
+#define CONSTRUCT_OBSERVEDCONTAINER(name) \
+    template ObservedContainer< name >& ObservedContainer< name >::operator=(const ObservedContainer< name >&); \
+    template ObservedContainer< name >::iterator ObservedContainer< name >::begin(); \
+    template ObservedContainer< name >::const_iterator ObservedContainer< name >::begin() const; \
+    template ObservedContainer< name >::iterator ObservedContainer< name >::end(); \
+    template ObservedContainer< name >::const_iterator ObservedContainer< name >::end() const; \
+    template ObservedContainer< name >::reverse_iterator ObservedContainer< name >::rbegin(); \
+    template ObservedContainer< name >::const_reverse_iterator ObservedContainer< name >::rbegin() const; \
+    template ObservedContainer< name >::reverse_iterator ObservedContainer< name >::rend(); \
+    template ObservedContainer< name >::const_reverse_iterator ObservedContainer< name >::rend() const; \
+    template bool ObservedContainer< name >::empty() const; \
+    template size_t ObservedContainer< name >::size() const; \
+    template size_t ObservedContainer< name >::max_size() const; \
+    template ObservedContainer< name >::mapped_type &ObservedContainer< name >::operator[](const key_type&); \
+    template std::pair<ObservedContainer< name >::iterator,bool> ObservedContainer< name >::insert (const value_type&); \
+    template size_t ObservedContainer< name >::erase ( const key_type& x ); \
+    template void ObservedContainer< name >::clear(); \
+    template ObservedContainer< name >::iterator ObservedContainer< name >::find ( const key_type& x ); \
+    template ObservedContainer< name >::const_iterator ObservedContainer< name >::find ( const key_type& x ) const; \
+    template size_t ObservedContainer< name >::count ( const key_type& x ) const; \
+    template ObservedContainer< name >::internal_iterator ObservedContainer< name >::begin_internal(); \
+    template ObservedContainer< name >::reverse_internal_iterator ObservedContainer< name >::rbegin_internal(); \
+    template ObservedContainer< name >::internal_iterator ObservedContainer< name >::end_internal(); \
+    template ObservedContainer< name >::reverse_internal_iterator ObservedContainer< name >::rend_internal(); \
+
+#endif /* OBSERVEDCONTAINER_IMPL_HPP_ */
Index: src/Patterns/ObservedIterator.hpp
===================================================================
--- src/Patterns/ObservedIterator.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Patterns/ObservedIterator.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -108,4 +108,9 @@
   }
 
+  value_type *operator->(){
+    acquireLock();
+    return &(*iter);
+  }
+
   // when we turn into a const iterator we can loose our lock
   operator typename _Set::const_iterator() {
Index: src/Patterns/Observer.cpp
===================================================================
--- src/Patterns/Observer.cpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Patterns/Observer.cpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -6,8 +6,12 @@
  */
 
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
 #include "Helpers/MemDebug.hpp"
 
 #include "Observer.hpp"
-
 
 #include <iostream>
Index: src/Patterns/Observer.hpp
===================================================================
--- src/Patterns/Observer.hpp	(revision 8e463e3743873aa2485a58f66cc88fde13f11d11)
+++ src/Patterns/Observer.hpp	(revision 49a1362bb32b57e917e16bb423d8f5a7ec95ac2f)
@@ -170,5 +170,5 @@
   //! @cond
   // Structure for RAII-Style notification
-protected:
+public:
   /**
    * This structure implements the Observer-mechanism RAII-Idiom.
@@ -241,4 +241,5 @@
 #define OBSERVE Observable::_Observable_protector PASTE(_scope_obs_protector_,__LINE__)(this)
 #define NOTIFY(notification) do{Observable::enque_notification_internal(this,notification);}while(0)
+#define LOCK_OBSERVABLE(observable) Observable::_Observable_protector PASTE(_scope_obs_protector_,__LINE__)(&(observable))
 
 #endif /* OBSERVER_HPP_ */
